﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;

namespace WpfApplication42
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Thread ujSzal;

        public delegate void FvMutato(int i);

        public volatile int KezdoErtek = 0;

        public MainWindow()
        {
            InitializeComponent();
            ujSzal = new Thread(new ThreadStart(kiiratas));
        }

        private void ProgBarModositas(int i)
        {
            this.progressBar1.Value = i;
            label1.Content = "Százalék " + i.ToString();
        }

        private void kiiratas()
        {

            for (int i = KezdoErtek; i < 100; i++)
            {
                Thread.Sleep(100);
                KezdoErtek = i;
                FvMutato mutato = new FvMutato(ProgBarModositas);
                this.button1.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.Normal, mutato, i);
                
                //ProgBarModositas(i);
            }
            MessageBox.Show("Kész");
        
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            button2.Content = "Mégse";
            if (ujSzal.ThreadState == ThreadState.Unstarted)
            {
                KezdoErtek = 0;
                ujSzal.Start();    
            }
            if (ujSzal.ThreadState == ThreadState.Aborted)
            {
                KezdoErtek = 0;
                ujSzal = new Thread(new ThreadStart(kiiratas));
                ujSzal.Start();
            }            
        }
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            if ((ujSzal != null && ujSzal.ThreadState != ThreadState.Aborted))
            {
                button2.Content = "Folytat";
                ujSzal.Abort();
            }
            else
            {
                if ((ujSzal != null && ujSzal.ThreadState == ThreadState.Aborted))
                {
                    button2.Content = "Mégse";
                    ujSzal = new Thread(new ThreadStart(kiiratas));
                    ujSzal.Start();
                }
            }

        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            ujSzal.Abort();
        }

    }
}
